#!/usr/bin/ksh
# by Paul.Popp
 
set -x
LOG="/tmp/installationprotokoll.txt"
DATUM=`date +%d.%m.%Y` 
HOSTNAME=`hostname`

if [ $# -eq "0" ]; then
	echo "Bitte Mailadresse mit angeben"
	exit 1
elif [ $# -ge "2" ]; then
	echo "Zuviele Mailadressen angeben"
	exit 2
elif [ $# -eq "1" ]; then
	MAILNAME=$1
fi

echo "\n\n"> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "\n\n">> $LOG
echo "# #     #  ##### #####  ##   #      #       ##  ##### #   ##   #     #  #####	  " >> $LOG
echo "# ##    # #        #   #  #  #      #      #  #   #   #  #  #  ##    # #     	  " >> $LOG
echo "# # #   # #        #  #    # #      #     #    #  #   # #    # # #   # #     	  " >> $LOG
echo "# #  #  #  ####    #  #    # #      #     #    #  #   # #    # #  #  #  ####  ####  " >> $LOG
echo "# #   # #      #   #  ###### #      #     ######  #   # #    # #   # #      #	  " >> $LOG
echo "# #    ##      #   #  #    # #      #     #    #  #   #  #  #  #    ##      # 	  " >> $LOG
echo "# #     # #####    #  #    # #####  ##### #    #  #   #   ##   #     # ##### 	  " >> $LOG
echo "\n\n\n\n\n\n\n\n">> $LOG
echo "#####  #####    ##  #######  ##   #   #   ##   #      #      " >> $LOG
echo "#    # #    #  #  #    #    #  #  #  #   #  #  #      #      " >> $LOG
echo "#    # #    # #    #   #   #    # # #   #    # #      #      " >> $LOG
echo "#####  #####  #    #   #   #    # ###   #    # #      #      " >> $LOG
echo "#      #   #  #    #   #   #    # # #   #    # #      #      " >> $LOG
echo "#      #    #  #  #    #    #  #  #  #   #  #  #      #      " >> $LOG
echo "#      #    #   ##     #     ##   #   #   ##   ###### ###### " >> $LOG
echo "\n\n\n">> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "Maschine:      $HOSTNAME " >> $LOG
echo "Datum:         $DATUM " >> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n\n" >> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "|INSTALLIERTE PACKETE                                                              |">> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "\n\n">> $LOG
pkginfo >> $LOG
echo "\n\n">> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "| INSTALLIERTE PATCHES                                                             |">> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "\n\n">> $LOG
showrev -p >> $LOG
echo "\n\n">> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "| USER INFOS                                                                       |">> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "\n\n">> $LOG
if [ -r /etc/passwd ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/passwd                                                           " >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/passwd >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/shadow ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/shadow                                                           " >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/shadow >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/group ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/group                                                            " >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/group >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/shells ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/shells                                                           " >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/shells >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/login ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/default/login                                                    " >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/default/login >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/profile ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/profile                                                          " >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/profile >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/hosts.allow ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/hosts.allow                                                      " >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/hosts.allow >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/hosts.deny ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/hosts.deny                                                       " >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/hosts.deny >> $LOG
fi
echo "\n\n">> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "| SSH INFOS                                                                        |">> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "\n\n">> $LOG
homedirs=`cut -d":" -f1 /etc/passwd`
olddir="no"
for user in $homedirs
do
	dir=`grep $user /etc/passwd | cut -d":" -f6 | head -1`
	if [ $olddir == $dir ];then
		olddir=$dir
	else
		if [ -d $dir\/.ssh2 ]; then
			echo "************************************************************************************" >> $LOG
			echo "* Authorized ssh2-user in $dir/.ssh2 for $user:" >> $LOG
			echo "************************************************************************************" >> $LOG
			if [ -f $dir/.ssh2/authorization ]; then
				cat $dir/.ssh2/authorization >> $LOG
			else
				 echo -- >> $LOG
			fi
			echo "\n\n">> $LOG
			if [ -d $dir\/.ssh ]; then
				echo "************************************************************************************" >> $LOG
        			echo "* Authorized ssh1-user in $dir/.ssh for $user:" >>$LOG
				echo "************************************************************************************" >> $LOG
        			if [ -f $dir/.ssh/authorized_keys ]; then
                			cat $dir/.ssh/authorized_keys >>$LOG
        			else
				 	echo -- >> $LOG
        			fi
        			if [ -f $dir\/.ssh/authorized_keys2 ]; then
					echo "************************************************************************************" >> $LOG
               		 		echo "* OpenSSH ssh2-user in $dir/.ssh/authorized_keys2 for $user:" >>$LOG
					echo "************************************************************************************" >> $LOG
               		 		cat $dir/.ssh/authorized_keys2 >>$log
        			fi
				echo "\n\n">> $LOG
        		fi
			olddir=$dir
        	fi
        fi
done
echo "\n\n">> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "| NETZ INFOS                                                                       |" >> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "\n\n">> $LOG
echo "************************************************************************************" >> $LOG
echo "* netstat -i" >> $LOG
echo "************************************************************************************" >> $LOG
netstat -i >> $LOG 
echo "\n\n">> $LOG
echo "************************************************************************************" >> $LOG
echo "* netstat -rn" >> $LOG
echo "************************************************************************************" >> $LOG
netstat -rn >> $LOG 
echo "\n\n">> $LOG
echo "************************************************************************************" >> $LOG
echo "* netstat -an " >> $LOG
echo "************************************************************************************" >> $LOG
netstat -an >> $LOG 
echo "\n\n">> $LOG
echo "************************************************************************************" >> $LOG
echo "* netstat -a" >> $LOG
echo "************************************************************************************" >> $LOG
netstat -a >> $LOG 
echo "\n\n">> $LOG
if [ -r /etc/hosts ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/hosts" >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/hosts >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/protocols ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/protocols" >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/protocols >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/services ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/services" >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/services >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/inetd.conf ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/inetd.conf" >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/inetd.conf >> $LOG
	echo "\n\n">> $LOG
fi
echo "************************************************************************************" >> $LOG
echo "* Inhalt des Verzeichnisses /etc/init" >> $LOG
echo "************************************************************************************" >> $LOG
ls /etc/init >> $LOG
echo "\n\n">> $LOG
if [ -r /etc/syslog.conf ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/syslog.conf" >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/syslog.conf >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/ftpusers ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/ftpusers" >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/ftpusers >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/inittab ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/inittab" >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/inittab >> $LOG
	echo "\n\n">> $LOG
fi
if [ -r /etc/vfstab ];then
	echo "************************************************************************************" >> $LOG
	echo "* Inhalt der /etc/vfstab" >> $LOG
	echo "************************************************************************************" >> $LOG
	cat /etc/vfstab >> $LOG
	echo "\n\n">> $LOG
fi
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "| FILESYSTEM INFOS                                                                 |" >> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "************************************************************************************" >> $LOG
echo "* df -kl" >> $LOG
echo "************************************************************************************" >> $LOG
df -kl >> $LOG
echo "\n\n">> $LOG
if pkginfo | grep VRTSvxvm >/dev/null;then
	echo "************************************************************************************" >> $LOG
	echo "* VERITAS Volume Manager infos">> $LOG
	echo "************************************************************************************" >> $LOG
	echo "\n\n">> $LOG
	echo "************************************************************************************" >> $LOG
	echo "* VERITAS Licencs info">> $LOG
	echo "************************************************************************************" >> $LOG
	vxlicense -p >> $LOG
	echo "\n\n">> $LOG
	echo "************************************************************************************" >> $LOG
	echo "* Uebersicht ueber Volume Manager diskgroups" >> $LOG
	echo "************************************************************************************" >> $LOG
	vxdg list >> $LOG
	echo "\n\n">> $LOG
	echo "************************************************************************************" >> $LOG
	echo "* Uebersicht ueber Volume Manager Disks" >> $LOG
	echo "************************************************************************************" >> $LOG
	vxdisk list >> $LOG
	echo "\n\n">> $LOG
	echo "************************************************************************************" >> $LOG
	echo "* Uebersicht ueber den aktuellen Status des Volume Managers " >> $LOG
	echo "************************************************************************************" >> $LOG
	vxprint -ht >> $LOG
fi
echo "\n\n">> $LOG
echo "************************************************************************************" >> $LOG
echo "* find / -local -perm -4000 -ls" >> $LOG
echo "************************************************************************************" >> $LOG
find / -local -perm -4000 -ls >> $LOG 2>/dev/null
echo "\n\n">> $LOG
echo "************************************************************************************" >> $LOG
echo "* find / -local -perm -2000 -ls" >> $LOG
echo "************************************************************************************" >> $LOG
find / -local -perm -2000 -ls >> $LOG 2>/dev/null
echo "\n\n">> $LOG
echo "************************************************************************************" >> $LOG
echo "* find / -local -perm -0002 -ls (ohne links und devs)" >> $LOG
echo "************************************************************************************" >> $LOG
find / -local -perm -0002 -ls >> /tmp/find.install.tmp 2>/dev/null
grep -v "lrwxrwxrwx" /tmp/find.install.tmp >> /tmp/find.install_1.tmp 
grep -v "/dev/" /tmp/find.install_1.tmp >> $LOG
rm /tmp/find.install.tmp /tmp/find.install_1.tmp
echo "\n\n">> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "| JOB INFOS                                                                        |" >> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "\n\n">> $LOG
echo "************************************************************************************" >> $LOG
echo "* /var/spool/cron/atjobs" >> $LOG
echo "************************************************************************************" >> $LOG
cat /var/spool/cron/atjobs >> $LOG
echo "\n\n">> $LOG
echo "************************************************************************************" >> $LOG
echo "* ps -eaf" >> $LOG
echo "************************************************************************************" >> $LOG
ps -eaf >> $LOG
echo "\n\n">> $LOG

echo "+----------------------------------------------------------------------------------+" >> $LOG
echo "| ENDE des Installationsprotokoll                                                  |">> $LOG
echo "+----------------------------------------------------------------------------------+" >> $LOG
if [ -f $LOG ]; then
	mailx -s "Installationsprotokoll von $HOSTNAME am $DATUM" $MAILNAME < $LOG
fi
rm $LOG
