#! /bin/sh
#
# rapport.sh
#
# Autor:	5.1.1999 R.Bender
# Version:	2.1
#
# Aenderungen:
#	19.01.2000 Kuehn	Eintrag eines neuen Mail Empfaengers
#	25.01.2000 R.Bender	schneide@dit.de neu
#	25.01.2000 R.Bender	bartaemi@dit.de neu
#	20.04.2000 M. Hofmann	- rapport.txt und rapport.sh nach 
#				  /var/root/cronjob verlegt.
#				- Suche nach Benutzern ohne Passwort eingefuegt.
#				- Variable POSTLISTE eingefuehrt.
#	30.04.2002 D.Schaefer	- bei df awk und sort eingebaut
#				- Einbau zum herausfinden der unterschiedlichen
#				  Interfaces
# 	02.05.2002 D.Schaefer	- Bei AWK Variable LAEN eingebaut
#	06.06.2002 D.Schaefer	- Einruecken von Auffaelligkeiten eingebaut.
#       26.09.2002 D.Schaefer   - for Schleife bei ifconfgig eingebaut.
#                               - df um Option l (only locale Filesystem) erweitert
#	27.09.2002 D.Schaefer	- Ausgabeformat geaendert
#	22.10.2002 D.Schaefer	- Ausgabeformat geaendert
#	30.10.2002 D.Schaefer	- if Abfrage fuer /var/adm/sulog eingebaut
#	19.11.2002 D.schaefer	- if Abfrage beim loeschen der tmp Dateien eingebaut
#				  mail durch mailx ersetzt. Kommentare eingebaut
#set -x
chmod 700 $0
log="/var/root/cronjob/rapport.txt"
logtmp="/tmp/rapport.tmp"

POSTLISTE="unix-admins_dl@dit.de"
#POSTLISTE="dirk.schaefer@dit.de"

if [ -f $log ]
then
  /bin/rm $log
fi

#########################################################################################
# uname, date, who	 								#
#########################################################################################

/bin/chmod og-rwx $log
echo "#############################################################################################" >> $log
echo "# GENERAL SYSTEM STATE:\t\t\t\t\t\t\t\t\t\t\t\t  #">> $log
echo "#############################################################################################" >> $log
echo >> $log
/bin/uname -a >> $log
/bin/date >> $log
/bin/who -r >> $log
echo >> $log

#########################################################################################
# Ueberpruefung des Netzes								#
#########################################################################################

echo "\n\n">> $log
echo "#############################################################################################" >> $log
echo "# NETWORK:\t\t\t\t\t\t\t\t\t\t\t\t\t\t  #" >> $log
echo "#############################################################################################" >> $log
echo >> $log
HOST=`/usr/bin/hostname`
INTERFACE=`/usr/bin/netstat -i | /usr/bin/grep $HOST |  /usr/bin/awk '{print $1}'`
for i in $INTERFACE
do
	/usr/sbin/ifconfig $i >> $log
	echo "--------------------------------------------------------------------------" >> $log
done
echo >> $log
/usr/bin/netstat -i >> $log
echo "-----------------------------------------------------------------------------------" >> $log
/usr/bin/netstat -nr >> $log

#########################################################################################
# Ueberpruefung der Filesysteme								#
#########################################################################################

echo "\n\n">> $log
echo "#############################################################################################" >> $log
echo "# FILESYSTEM:\t\t\t\t\t\t\t\t\t\t\t\t\t  #">> $log
echo "#############################################################################################" >> $log
echo >> $log
/usr/bin/df -kl | /usr/bin/grep -v "Filesystem " | /usr/bin/sort -n +4 > $logtmp
LAEN=`/usr/xpg4/bin/awk '{print length($1)}' $logtmp | /usr/bin/sort -un | /usr/bin/tail -1`
LAEN=`/usr/bin/expr $LAEN + 1`
echo "Filesystem kbytes used avail capacity Mounted_on" |\
/usr/xpg4/bin/awk '{printf "%-'$LAEN's%10s%10s%10s%9s%-s\n",$1,$2,$3,$4," "$5," "$6}' >> $log
while read line; do
	full=`echo $line|/usr/xpg4/bin/awk '{print $5}'|/usr/bin/grep "100%" | /usr/bin/cut -d"%" -f1`
	full=${full:-0}
	notuse=`echo $line|/usr/xpg4/bin/awk '{print $6}'|/usr/bin/egrep "cdrom"|/usr/bin/cut -d"/" -f2`
	notuse=${notuse:-nixda}
	if [ $full -eq 100 -a $notuse != cdrom ]; then
		echo "\n#############################################################################################" >> $log
		echo "# FULL DISKS\t\t\t\t\t\t\t\t\t\t\t\t\t  #" >> $log
		echo "#############################################################################################\n" >> $log
		echo $line | /usr/xpg4/bin/awk '{printf "\t%-'$LAEN's%10s%10s%10s%9s%-s\n",$1,$2,$3,$4," "$5," "$6}' >> $log
	else
		echo $line | /usr/xpg4/bin/awk '{printf "%-'$LAEN's%10s%10s%10s%9s%-s\n",$1,$2,$3,$4," "$5," "$6}' >> $log
	fi
done < $logtmp
if [ -s $logtmp ]; then /usr/bin/rm $logtmp; fi

#########################################################################################
# Ueberpruefung der SECURITY (last, sulog, /etc/shadow					#
#########################################################################################

echo "\n\n">> $log
echo "#############################################################################################" >> $log
echo "# SECURITY:\t\t\t\t\t\t\t\t\t\t\t\t\t\t  #" >> $log
echo "#############################################################################################" >> $log
echo >> $log
/usr/bin/last | /usr/bin/grep root | /usr/bin/head >> $log
echo >> $log
#/usr/bin/grep root /var/adm/sulog | /usr/bin/tail >> $logtmp
if [ -s /var/adm/sulog ]; then
	/usr/bin/cat /var/adm/sulog | /usr/bin/grep root | /usr/bin/tail >> $logtmp
	while read line ; do
		USER=`echo $line | /usr/xpg4/bin/awk '{print $NF}'| /usr/bin/cut -d"-" -f1|head -1`
		if [ $USER != root ]; then
			USER=`echo $line | /usr/xpg4/bin/awk '{print $NF}'| /usr/bin/cut -d"-" -f2|head -1`
			LAEN=`echo $USER| wc -c`
			LAEN=`/usr/bin/expr 73 - $LAEN`
			echo  "\t$line" >> $log
		else
			echo  "$line" >> $log
		fi
	done < $logtmp
else
	echo "/var/adm/sulog hat keine Eintaege!" >> $log
fi
if [ -s $logtmp ];then /usr/bin/rm $logtmp; fi

#########################################################################################
# Ueberpruefung der /etc/shadow Passwoerter						#
#########################################################################################

echo "\n\n">> $log
echo "#############################################################################################" >> $log
echo "# BENUTZER OHNE PASSWORT\t\t\t\t\t\t\t\t\t\t\t  #" >> $log
echo "#############################################################################################" >> $log
echo >> $log
/usr/bin/nawk '								\
    BEGIN								\
    {									\
	FS = ":";							\
    }									\
    {									\
	if (length($2) < 10 && $2 != "*" && $2 != "NP" && $2 != "*LK*") \
	{								\
	    printf"%s\n", $1;						\
	}								\
    }' /etc/shadow >> $log

#########################################################################################
# hier wird die Mail versendet								#
#########################################################################################

if [ -f $log ]
then
	/usr/bin/cat $log | /usr/bin/mailx -s"RAPPORTLOG for SOLARIS `/usr/bin/hostname`"  $POSTLISTE
else
	echo "Rapportdatei konnte nicht erstellt werden" |\
	/usr/bin/mailx -s "RAPPORTLOG for SOLARIS ERROR `/usr/bin/hostname`" $POSTLISTE
fi
