#!/usr/bin/sh
# by Dirk Schaefer
# veritas_check.sh
# Dass Skript ermittelt die aktuelle Veritas Volumemanger Konfiguration.
# Bei Aenderungen wird eine Mail versendet.
 
set -x
###################################################
# Variablen
###################################################
#MAIL_NAMEN="unix-admins_dl@dit.de"
MAIL_NAMEN="dirk.schaefer@dit.de"
LOG_MAIL="/var/root/log/veritas_mail.txt"
LOG_VERITAS="/var/root/log/veritas_info.txt"
TMP_LOG="/tmp/veritas_check.tmp"
DATUM=`date +%d.%m.%Y` 
HOSTNAME=`/usr/bin/hostname`
u="no"
###################################################
# Programm-Variablen
###################################################
CAT=/usr/bin/cat
DIFF=/usr/bin/diff
MAILX=/usr/bin/mailx
MV=/usr/bin/mv
PKGINFO=/usr/bin/pkginfo
RM=/usr/bin/rm
VXDG=/usr/sbin/vxdg
VXDISK=/usr/sbin/vxdisk
VXPRINT=/usr/sbin/vxprint

###################################################
# Programm
###################################################
${PKGINFO} VRTSvxvm >/dev/null 2>&1
ch=$?
if test $ch -ne 0; then
	exit $ch
fi

echo "+--------------------------------------------------------+" > $LOG_MAIL
echo "Maschine:      $HOSTNAME " >> $LOG_MAIL
echo "Datum:         $DATUM " >> $LOG_MAIL
echo "+--------------------------------------------------------+" >> $LOG_MAIL
echo "">> $LOG_MAIL
echo "+--------------------------------------------------------+" >> $LOG_MAIL
echo "Uebersicht ueber Volume Manager diskgroups" >> $LOG_MAIL
echo "+--------------------------------------------------------+" >> $LOG_MAIL
echo "">> $LOG_MAIL
${VXDG} list > $TMP_LOG
${CAT}  $TMP_LOG >> $LOG_MAIL
${CAT}  $TMP_LOG > $LOG_VERITAS
echo "">> $LOG_MAIL
echo "+--------------------------------------------------------+" >> $LOG_MAIL
echo "Uebersicht ueber Volume Manager Disks" >> $LOG_MAIL
echo "+--------------------------------------------------------+" >> $LOG_MAIL
${VXDISK} list >> $TMP_LOG
${CAT}  $TMP_LOG >> $LOG_MAIL
${CAT}  $TMP_LOG > $LOG_VERITAS
echo "">> $LOG_MAIL
echo "">> $LOG_MAIL
echo "+--------------------------------------------------------+" >> $LOG_MAIL
echo "Uebersicht ueber den aktuellen Status des Volume Managers " >> $LOG_MAIL
echo "+--------------------------------------------------------+" >> $LOG_MAIL
${VXPRINT} -ht >> $TMP_LOG
${CAT}  $TMP_LOG >> $LOG_MAIL
${CAT}  $TMP_LOG > $LOG_VERITAS

${DIFF} $LOG_VERITAS $LOG_VERITAS\.old >/dev/null 2>&1
if test $? -ne "0"; then
	u="yes"
	if test -s $LOG_VERITAS; then
		${MV} $LOG_VERITAS $LOG_VERITAS\.old
	fi
else
	u="no"
fi

if test $u = "yes"; then 
	${CAT} $LOG_MAIL| ${MAILX} -s "Vertias Infos $HOSTNAME $DATUM" dirk.schaefer@dit.de < $LOG_MAIL
fi
${RM} $TMP_LOG
