#!/usr/bin/perl
#################################################################
# Dirk Schaefer 2002						#
# log_checker.pl						#
# Programm zum durchsuchen von Logdateien nach bestimmten Code-	#
# woertern. Diese Meldungen werden in eine Mail gefasst und an	#
# die Systemverwalter geschickt.				#
#################################################################
# Aenderungen							#
# Aufgabe geaendert				DS	05.09.02#
# Mail wird nur bei einem gefundenen Muster 			#
# versendet					DS	06.09.02#
# Fehler beim erstellen der Maildatei beseitigt DS	10.09.02#
#################################################################
# Module
#################################################################
use Time::Local;
#use File::Path;
use Sys::Hostname;
use Getopt::Std;

#################################################################
# Variablen
#################################################################
$configdatei="/var/root/config/log_checker.cfg";
$x=1;
$host = &hostname;
$opt_d = $opt_h = 0;
$ok = "nix";


#################################################################
# Programm 
#################################################################
getopts('dhv');
if($opt_d == 1 && $opt_h == 0 && $opt_v == 0){
	&time;
	&read_config;
	&check_ausgabe;
} elsif($opt_h == 0 && $opt_v == 0) {
	&time;
	&read_config;
	&check_log;
	if($ok eq "ok"){
		&mailversand;
	}
	&end_skript;
}
if($opt_h == 1){
	@prog = split("/",$0);
	print "usage: $prog[1] -d -h -v\n\n";
	print "\t-d\tNur Ausgabe der gefunden Meldungen in den Logdateien\n";
	print "\t-h\tDiese Ausgabe\n";
	print "\t-v\tVersionsnummer\n";
	print "\nusage: $prog[1] \n\n";
	print "\tEs wird nur bei einem gefundenen Muster eine E-Mail versendet.\n";
	exit;
}
if($opt_v == 1){
	&read_config;
	@prog = split("/",$0);
	print "Version: \n\n$prog[1] $version\n";
	exit;
}



#################################################################
# Funktionen
#################################################################

sub read_config
{
	open(CONFIG,$configdatei);
	@suche=<CONFIG>;
	@ergebnis=grep {/=/} @suche;
	foreach $i (@ergebnis) {
		if($i=~/logdateien/) {
			@h=split("=",$i);
			@logdateien=split(",",$h[1]);
		}elsif($i=~/code/) {
			@h=split("=",$i);
			@datei=split(";",$h[0]);
			#@code{$datei[1]}=split(",",$h[1]);
			$code{$datei[1]}=$h[1];
#			print "Suchmuster:\t@code{$datei[1]}\n";
		}elsif($i=~/version/){
			@h=split("=",$i);
			$version=$h[1];
		}else {
			@h=split("=",$i);
			$mailname=$h[1];
			$mailname = "unix\-admins_dl\@dit.de";
		}
	}
	close(CONFIG);  
}


sub time
{
	@Monatsnamen = ("","Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"); 
	@zeit = localtime(time);
	$zeit[5] += 1900;
	$zeit[4]++;
	if ($zeit[1]<10) {$zeit[1]="0$zeit[1]"}
	if ($zeit[2]<10) {$zeit[2]="0$zeit[2]"}
	if ($zeit[3]<10) {$zeit[3]="0$zeit[3]"}
	if ($zeit[4]<10) {$zeit[4]="0$zeit[4]"}
	$ak_monat = $zeit[4];
	$datum = "Startzeit: $zeit[3].$zeit[4].$zeit[5] um $zeit[2]:$zeit[1] Uhr";
	$schalt = $zeit[5] % 4;
	if($schalt == "0") {
		$schalt = $zeit[5] % 100;
		if($schalt =~ "0") {
			$schalt = $zeit[5] % 400;
			if($schalt == "0") {
				$schaltjahr = "ja";
			} else {
				$schaltjahr = "nein";
			}
		} else {
			$schaltjahr = "ja";
		}
	} else {
		$schaltjahr = "nein";
	}

	if($zeit[3] == 01) {
		if($zeit[4] == 01) { 
			$tag = 31;
			$zeit[4] = 12;
			$monat = Dec;
			$zeit[5] =  $zeit[5] - 1;
		}elsif($zeit[4] == "02"||$zeit[4] == "04"||$zeit[4] == "06"||$zeit[4] == "08"||$zeit[4] == "09"||$zeit[4] == "11") { 
			$tag = 31;
			$vg_monat = $zeit[4] - 1;
			$monat = $Monatsnamen[$vg_monat];
			if ($vg_monat<10) {$vg_monat="0$vg_mona"}
		}elsif($zeit[4] == 03) {
			if($schaltjahr eq "ja") {
				$tag = 29;
			} else {
				$tag = 28;
			}
			$vg_monat = $zeit[4] - 1;
			$monat = $Monatsnamen[$vg_monat];
			if ($vg_monat<10) {$vg_monat="0$vg_mona"}
		}elsif($zeit[4] == "05"||$zeit[4] == "07"||$zeit[4] == "10"||$zeit[4] == "12") {
			$tag = 30;
			$vg_monat = $zeit[4] - 1;
			$monat = $Monatsnamen[$vg_monat];
			if ($vg_monat<10) {$vg_monat="0$vg_mona"}
		} 
	} else {
		$monat = $Monatsnamen[$zeit[4]];
		$vg_monat = $zeit[4];
		$tag = $zeit[3] - 1;
	}
}

sub check_ausgabe
{
	print "\n+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
	print "$datum\n";
	print "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
	print "\nDie folgenden Logdateien werden gecheckt:\n";
	foreach $log ( @logdateien ) {	
		@ausgabe=split("'",$log);
		print "\t-\t$ausgabe[1]\n";
	}
	print "\n\nERGEBNISSE:\n\n";
	foreach $log ( @logdateien ) {
		@q=split("'",$log);
		$log=$q[1];
		open(LOG, "$log") or print "\n!!! Kann $log nicht oeffnen !!!\n" ;
		print "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
		print "Logdatei: $log\n";
		print "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n\n";
		@suche=<LOG>;
		@d=split("/",$log);
		$laenge=$#d;
		$datei=$d[$laenge];
		@ergebnis_1 = grep{/$vg_monat\/$tag\ /||/$ak_monat\/$zeit[3]\ /||/$monat\ $tag\ /||/$monat\ $zeit[3]\ /||/\[$tag\/$monat\//||/\[$zeit[3]\/$monat\//} @suche;
		foreach(@ergebnis_1) {
			@code=split(",",$code{$datei});
			foreach $muster(@code) {
				@q=split("'",$muster);
				$muster=$q[1];
				print if /$muster/i;
				if(/$muster/i){$ok = "ok";}
			}
                }
		if($ok eq "nix"){print "Keine Fehlermeldungen vorhanden.\n";}
		$ok = "nix";
		close(LOG);
		print "\n\n";
	}
}

sub check_log
{
#################################################################
# Es wird die messages/messages.0 Datei nach den oben festgelegten 
# Codewoertern fuer den vergangenen und aktuellen Tag durchsucht. 
# Die gefundenen Eintraege werden in eine Mail geschrieben und 
# mit der Funktion mailversand gesendet.   
#################################################################
	open(MAIL, ">>/tmp/log_checker.error.mail.txt");
	print MAIL "\n+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
	print MAIL "$datum\n";
	print MAIL "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
	$ok = "nix";
	foreach $log ( @logdateien ) {	
		$print = "Nein";
		@q=split("'",$log);
		$log=$q[1];
		open(LOG, "$log") or print MAIL "\n!!! Kann $log nicht oeffnen !!!\n" ;
		@suche=<LOG>;
		@d=split("/",$log);
		$laenge=$#d;
		$datei=$d[$laenge];
		@ergebnis_1 = grep{/$vg_monat\/$tag\ /||/$ak_monat\/$zeit[3]\ /||/$monat\ $tag\ /||/$monat\ $zeit[3]\ /||/\[$tag\/$monat\//||/\[$zeit[3]\/$monat\//} @suche;
		foreach(@ergebnis_1) {
			@code=split(",",$code{$datei});
			foreach $muster(@code) {
				@q=split("'",$muster);
				$muster=$q[1];
#			if(/$muster/i){print "$muster\n";}
				if(/$muster/i){
					$ok = "ok"; 
					if($print eq "Nein"){
						print MAIL "\n\n+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n";
						print MAIL "Logdatei: $log\n";
						print MAIL "+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++\n\n";
						$print = "Ja";
					}
				}
				print MAIL if /$muster/i;
			}
                }
		close(LOG);
		print MAIL "\n\n";
	}
	close(MAIL);
}

sub mailversand
{
	system("/usr/bin/cat /tmp/log_checker.error.mail.txt | /usr/bin/mailx -s 'log_checker $host' $mailname ") and print "\n!!! Konnte mail nicht versenden !!!\n";
}

sub end_skript
{
        unlink "/tmp/log_checker.error.mail.txt";
}

